/* dconf-update.c generated by valac 0.43.4, the Vala compiler
 * generated from dconf-update.vala, do not modify */

/*
 * Copyright © 2010 Codethink Limited
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the licence, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Ryan Lortie <desrt@desrt.ca>
 */

#include "../gvdb/gvdb-builder.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <glib/gstdio.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

GvdbItem* get_parent (GHashTable* table,
                      const gchar* name);
GSList* list_directory (const gchar* dirname,
                        mode_t mode,
                        GError** error);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
GHashTable* read_locks_directory (const gchar* dirname,
                                  GError** error);
GHashTable* read_directory (const gchar* dirname,
                            GError** error);
time_t get_directory_mtime (const gchar* dirname,
                            struct stat* dir_buf,
                            GError** error);
void maybe_update_from_directory (const gchar* dirname,
                                  GError** error);
void update_all (const gchar* dirname,
                 GError** error);
void dconf_compile (gchar** args,
                    gint args_length1,
                    GError** error);
void dconf_update (gchar** args,
                   gint args_length1,
                   GError** error);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 95 "dconf-update.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "glib-2.0.vapi"
		result = maxlen;
#line 1394 "glib-2.0.vapi"
		return result;
#line 118 "dconf-update.c"
	} else {
		gchar* _tmp2_;
#line 1396 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "glib-2.0.vapi"
		return result;
#line 127 "dconf-update.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1403 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 146 "dconf-update.c"
	} else {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 150 "dconf-update.c"
	}
#line 1405 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 156 "dconf-update.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 166 "dconf-update.c"
	}
#line 1412 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1413 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1414 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 174 "dconf-update.c"
	} else {
#line 1416 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 178 "dconf-update.c"
	}
#line 1418 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1419 "glib-2.0.vapi"
		len = string_length - offset;
#line 184 "dconf-update.c"
	}
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "glib-2.0.vapi"
	result = _tmp3_;
#line 1422 "glib-2.0.vapi"
	return result;
#line 194 "dconf-update.c"
}

GvdbItem*
get_parent (GHashTable* table,
            const gchar* name)
{
	GvdbItem* result = NULL;
	GvdbItem* parent = NULL;
	gint end = 0;
	gchar* parent_name = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gconstpointer _tmp4_;
	GvdbItem* _tmp5_;
	GvdbItem* _tmp11_;
#line 20 "../bin/dconf-update.vala"
	g_return_val_if_fail (table != NULL, NULL);
#line 20 "../bin/dconf-update.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 23 "../bin/dconf-update.vala"
	end = 0;
#line 216 "dconf-update.c"
	{
		gint i = 0;
#line 25 "../bin/dconf-update.vala"
		i = 1;
#line 221 "dconf-update.c"
		{
			gboolean _tmp0_ = FALSE;
#line 25 "../bin/dconf-update.vala"
			_tmp0_ = TRUE;
#line 25 "../bin/dconf-update.vala"
			while (TRUE) {
#line 25 "../bin/dconf-update.vala"
				if (!_tmp0_) {
#line 230 "dconf-update.c"
					gint _tmp1_;
#line 25 "../bin/dconf-update.vala"
					_tmp1_ = i;
#line 25 "../bin/dconf-update.vala"
					i = _tmp1_ + 1;
#line 236 "dconf-update.c"
				}
#line 25 "../bin/dconf-update.vala"
				_tmp0_ = FALSE;
#line 25 "../bin/dconf-update.vala"
				if (!(string_get (name, (glong) i) != '\0')) {
#line 25 "../bin/dconf-update.vala"
					break;
#line 244 "dconf-update.c"
				}
#line 26 "../bin/dconf-update.vala"
				if (string_get (name, (glong) (i - 1)) == '/') {
#line 27 "../bin/dconf-update.vala"
					end = i;
#line 250 "dconf-update.c"
				}
			}
		}
	}
#line 31 "../bin/dconf-update.vala"
	_vala_assert (end != 0, "end != 0");
#line 33 "../bin/dconf-update.vala"
	_tmp2_ = string_substring (name, (glong) 0, (glong) end);
#line 33 "../bin/dconf-update.vala"
	parent_name = _tmp2_;
#line 34 "../bin/dconf-update.vala"
	_tmp3_ = parent_name;
#line 34 "../bin/dconf-update.vala"
	_tmp4_ = g_hash_table_lookup (table, _tmp3_);
#line 34 "../bin/dconf-update.vala"
	parent = (GvdbItem*) _tmp4_;
#line 36 "../bin/dconf-update.vala"
	_tmp5_ = parent;
#line 36 "../bin/dconf-update.vala"
	if (_tmp5_ == NULL) {
#line 271 "dconf-update.c"
		const gchar* _tmp6_;
		GvdbItem* _tmp7_;
		GvdbItem* _tmp8_;
		const gchar* _tmp9_;
		GvdbItem* _tmp10_;
#line 37 "../bin/dconf-update.vala"
		_tmp6_ = parent_name;
#line 37 "../bin/dconf-update.vala"
		_tmp7_ = gvdb_hash_table_insert (table, _tmp6_);
#line 37 "../bin/dconf-update.vala"
		parent = _tmp7_;
#line 38 "../bin/dconf-update.vala"
		_tmp8_ = parent;
#line 38 "../bin/dconf-update.vala"
		_tmp9_ = parent_name;
#line 38 "../bin/dconf-update.vala"
		_tmp10_ = get_parent (table, _tmp9_);
#line 38 "../bin/dconf-update.vala"
		gvdb_item_set_parent (_tmp8_, _tmp10_);
#line 291 "dconf-update.c"
	}
#line 41 "../bin/dconf-update.vala"
	_tmp11_ = parent;
#line 41 "../bin/dconf-update.vala"
	result = _tmp11_;
#line 41 "../bin/dconf-update.vala"
	_g_free0 (parent_name);
#line 41 "../bin/dconf-update.vala"
	return result;
#line 301 "dconf-update.c"
}

static void
_g_free0_ (gpointer var)
{
#line 46 "../bin/dconf-update.vala"
	var = (g_free (var), NULL);
#line 309 "dconf-update.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 46 "../bin/dconf-update.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 317 "dconf-update.c"
}

GSList*
list_directory (const gchar* dirname,
                mode_t mode,
                GError** error)
{
	GSList* result = NULL;
	GSList* list = NULL;
	GDir* dir = NULL;
	GDir* _tmp0_;
	const gchar* name = NULL;
	GError * _inner_error_ = NULL;
#line 44 "../bin/dconf-update.vala"
	g_return_val_if_fail (dirname != NULL, NULL);
#line 45 "../bin/dconf-update.vala"
	list = NULL;
#line 46 "../bin/dconf-update.vala"
	_tmp0_ = g_dir_open (dirname, (guint) 0, &_inner_error_);
#line 46 "../bin/dconf-update.vala"
	dir = _tmp0_;
#line 46 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 46 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 46 "../bin/dconf-update.vala"
		(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
#line 46 "../bin/dconf-update.vala"
		return NULL;
#line 347 "dconf-update.c"
	}
#line 49 "../bin/dconf-update.vala"
	while (TRUE) {
#line 351 "dconf-update.c"
		GDir* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* filename = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		struct stat buf = {0};
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		struct stat _tmp9_ = {0};
		gint _tmp10_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 49 "../bin/dconf-update.vala"
		_tmp1_ = dir;
#line 49 "../bin/dconf-update.vala"
		_tmp2_ = g_dir_read_name (_tmp1_);
#line 49 "../bin/dconf-update.vala"
		name = _tmp2_;
#line 49 "../bin/dconf-update.vala"
		_tmp3_ = name;
#line 49 "../bin/dconf-update.vala"
		if (!(_tmp3_ != NULL)) {
#line 49 "../bin/dconf-update.vala"
			break;
#line 378 "dconf-update.c"
		}
#line 50 "../bin/dconf-update.vala"
		_tmp4_ = name;
#line 50 "../bin/dconf-update.vala"
		if (g_str_has_prefix (_tmp4_, ".")) {
#line 51 "../bin/dconf-update.vala"
			continue;
#line 386 "dconf-update.c"
		}
#line 54 "../bin/dconf-update.vala"
		_tmp5_ = name;
#line 54 "../bin/dconf-update.vala"
		_tmp6_ = g_build_filename (dirname, _tmp5_, NULL);
#line 54 "../bin/dconf-update.vala"
		filename = _tmp6_;
#line 58 "../bin/dconf-update.vala"
		_tmp8_ = filename;
#line 58 "../bin/dconf-update.vala"
		_tmp10_ = stat (_tmp8_, &_tmp9_);
#line 58 "../bin/dconf-update.vala"
		buf = _tmp9_;
#line 58 "../bin/dconf-update.vala"
		if (_tmp10_ < 0) {
#line 58 "../bin/dconf-update.vala"
			_tmp7_ = TRUE;
#line 404 "dconf-update.c"
		} else {
			struct stat _tmp11_;
#line 58 "../bin/dconf-update.vala"
			_tmp11_ = buf;
#line 58 "../bin/dconf-update.vala"
			_tmp7_ = (_tmp11_.st_mode & S_IFMT) != mode;
#line 411 "dconf-update.c"
		}
#line 58 "../bin/dconf-update.vala"
		if (_tmp7_) {
#line 59 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 59 "../bin/dconf-update.vala"
			continue;
#line 419 "dconf-update.c"
		}
#line 62 "../bin/dconf-update.vala"
		_tmp12_ = filename;
#line 62 "../bin/dconf-update.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 62 "../bin/dconf-update.vala"
		list = g_slist_prepend (list, _tmp13_);
#line 49 "../bin/dconf-update.vala"
		_g_free0 (filename);
#line 429 "dconf-update.c"
	}
#line 65 "../bin/dconf-update.vala"
	result = list;
#line 65 "../bin/dconf-update.vala"
	_g_dir_close0 (dir);
#line 65 "../bin/dconf-update.vala"
	return result;
#line 437 "dconf-update.c"
}

GHashTable*
read_locks_directory (const gchar* dirname,
                      GError** error)
{
	GHashTable* result = NULL;
	GSList* files = NULL;
	GHashTable* table = NULL;
	GHashTable* _tmp3_;
	GSList* _tmp4_;
	GError * _inner_error_ = NULL;
#line 68 "../bin/dconf-update.vala"
	g_return_val_if_fail (dirname != NULL, NULL);
#line 452 "dconf-update.c"
	{
		GSList* _tmp0_ = NULL;
		GSList* _tmp1_;
		GSList* _tmp2_;
#line 72 "../bin/dconf-update.vala"
		_tmp1_ = list_directory (dirname, S_IFREG, &_inner_error_);
#line 72 "../bin/dconf-update.vala"
		_tmp0_ = _tmp1_;
#line 72 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "../bin/dconf-update.vala"
			if (g_error_matches (_inner_error_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
#line 465 "dconf-update.c"
				goto __catch0_g_file_error_noent;
			}
			goto __finally0;
		}
#line 72 "../bin/dconf-update.vala"
		_tmp2_ = _tmp0_;
#line 72 "../bin/dconf-update.vala"
		_tmp0_ = NULL;
#line 72 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 72 "../bin/dconf-update.vala"
		files = _tmp2_;
#line 71 "../bin/dconf-update.vala"
		(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
#line 480 "dconf-update.c"
	}
	goto __finally0;
	__catch0_g_file_error_noent:
	{
		GError* e = NULL;
#line 71 "../bin/dconf-update.vala"
		e = _inner_error_;
#line 71 "../bin/dconf-update.vala"
		_inner_error_ = NULL;
#line 75 "../bin/dconf-update.vala"
		result = NULL;
#line 75 "../bin/dconf-update.vala"
		_g_error_free0 (e);
#line 75 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 75 "../bin/dconf-update.vala"
		return result;
#line 498 "dconf-update.c"
	}
	__finally0:
#line 71 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 71 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 71 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 71 "../bin/dconf-update.vala"
		return NULL;
#line 509 "dconf-update.c"
	}
#line 78 "../bin/dconf-update.vala"
	_tmp3_ = gvdb_hash_table_new (NULL, NULL);
#line 78 "../bin/dconf-update.vala"
	table = _tmp3_;
#line 80 "../bin/dconf-update.vala"
	_tmp4_ = files;
#line 517 "dconf-update.c"
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
#line 80 "../bin/dconf-update.vala"
		filename_collection = _tmp4_;
#line 80 "../bin/dconf-update.vala"
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
#line 525 "dconf-update.c"
			gchar* _tmp5_;
			gchar* filename = NULL;
#line 80 "../bin/dconf-update.vala"
			_tmp5_ = g_strdup ((const gchar*) filename_it->data);
#line 80 "../bin/dconf-update.vala"
			filename = _tmp5_;
#line 532 "dconf-update.c"
			{
				gchar* contents = NULL;
				const gchar* _tmp6_;
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
#line 82 "../bin/dconf-update.vala"
				_tmp6_ = filename;
#line 82 "../bin/dconf-update.vala"
				g_file_get_contents (_tmp6_, &_tmp7_, NULL, &_inner_error_);
#line 82 "../bin/dconf-update.vala"
				_g_free0 (contents);
#line 82 "../bin/dconf-update.vala"
				contents = _tmp7_;
#line 82 "../bin/dconf-update.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 82 "../bin/dconf-update.vala"
					g_propagate_error (error, _inner_error_);
#line 82 "../bin/dconf-update.vala"
					_g_free0 (contents);
#line 82 "../bin/dconf-update.vala"
					_g_free0 (filename);
#line 82 "../bin/dconf-update.vala"
					_g_hash_table_unref0 (table);
#line 82 "../bin/dconf-update.vala"
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 82 "../bin/dconf-update.vala"
					return NULL;
#line 562 "dconf-update.c"
				}
#line 84 "../bin/dconf-update.vala"
				_tmp8_ = contents;
#line 84 "../bin/dconf-update.vala"
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "\n", 0);
#line 568 "dconf-update.c"
				{
					gchar** line_collection = NULL;
					gint line_collection_length1 = 0;
					gint _line_collection_size_ = 0;
					gint line_it = 0;
#line 84 "../bin/dconf-update.vala"
					line_collection = _tmp10_;
#line 84 "../bin/dconf-update.vala"
					line_collection_length1 = _vala_array_length (_tmp9_);
#line 84 "../bin/dconf-update.vala"
					for (line_it = 0; line_it < _vala_array_length (_tmp9_); line_it = line_it + 1) {
#line 580 "dconf-update.c"
						gchar* _tmp11_;
						gchar* line = NULL;
#line 84 "../bin/dconf-update.vala"
						_tmp11_ = g_strdup (line_collection[line_it]);
#line 84 "../bin/dconf-update.vala"
						line = _tmp11_;
#line 587 "dconf-update.c"
						{
							const gchar* _tmp12_;
#line 85 "../bin/dconf-update.vala"
							_tmp12_ = line;
#line 85 "../bin/dconf-update.vala"
							if (g_str_has_prefix (_tmp12_, "/")) {
#line 594 "dconf-update.c"
								GHashTable* _tmp13_;
								const gchar* _tmp14_;
#line 86 "../bin/dconf-update.vala"
								_tmp13_ = table;
#line 86 "../bin/dconf-update.vala"
								_tmp14_ = line;
#line 86 "../bin/dconf-update.vala"
								gvdb_hash_table_insert_string (_tmp13_, _tmp14_, "");
#line 603 "dconf-update.c"
							}
#line 84 "../bin/dconf-update.vala"
							_g_free0 (line);
#line 607 "dconf-update.c"
						}
					}
#line 84 "../bin/dconf-update.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 612 "dconf-update.c"
				}
#line 80 "../bin/dconf-update.vala"
				_g_free0 (contents);
#line 80 "../bin/dconf-update.vala"
				_g_free0 (filename);
#line 618 "dconf-update.c"
			}
		}
	}
#line 91 "../bin/dconf-update.vala"
	result = table;
#line 91 "../bin/dconf-update.vala"
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 91 "../bin/dconf-update.vala"
	return result;
#line 628 "dconf-update.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 109 "../bin/dconf-update.vala"
	return self ? g_error_copy (self) : NULL;
#line 636 "dconf-update.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 655 "dconf-update.c"
}

GHashTable*
read_directory (const gchar* dirname,
                GError** error)
{
	GHashTable* result = NULL;
	GHashTable* table = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GSList* files = NULL;
	GSList* _tmp2_;
	GCompareFunc _tmp3_;
	GSList* _tmp4_;
	GHashTable* locks = NULL;
	gchar* _tmp78_;
	gchar* _tmp79_;
	GHashTable* _tmp80_;
	GHashTable* _tmp81_;
	GHashTable* _tmp82_;
	GError * _inner_error_ = NULL;
#line 94 "../bin/dconf-update.vala"
	g_return_val_if_fail (dirname != NULL, NULL);
#line 95 "../bin/dconf-update.vala"
	_tmp0_ = gvdb_hash_table_new (NULL, NULL);
#line 95 "../bin/dconf-update.vala"
	table = _tmp0_;
#line 96 "../bin/dconf-update.vala"
	_tmp1_ = table;
#line 96 "../bin/dconf-update.vala"
	gvdb_hash_table_insert (_tmp1_, "/");
#line 98 "../bin/dconf-update.vala"
	_tmp2_ = list_directory (dirname, S_IFREG, &_inner_error_);
#line 98 "../bin/dconf-update.vala"
	files = _tmp2_;
#line 98 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 98 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 98 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 98 "../bin/dconf-update.vala"
		return NULL;
#line 699 "dconf-update.c"
	}
#line 99 "../bin/dconf-update.vala"
	_tmp3_ = ((GCompareFunc) g_strcmp0);
#line 99 "../bin/dconf-update.vala"
	files = g_slist_sort (files, _tmp3_);
#line 100 "../bin/dconf-update.vala"
	files = g_slist_reverse (files);
#line 102 "../bin/dconf-update.vala"
	_tmp4_ = files;
#line 709 "dconf-update.c"
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
#line 102 "../bin/dconf-update.vala"
		filename_collection = _tmp4_;
#line 102 "../bin/dconf-update.vala"
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
#line 717 "dconf-update.c"
			gchar* _tmp5_;
			gchar* filename = NULL;
#line 102 "../bin/dconf-update.vala"
			_tmp5_ = g_strdup ((const gchar*) filename_it->data);
#line 102 "../bin/dconf-update.vala"
			filename = _tmp5_;
#line 724 "dconf-update.c"
			{
				GKeyFile* kf = NULL;
				GKeyFile* _tmp6_;
				GKeyFile* _tmp16_;
				gsize _tmp17_ = 0;
				gchar** _tmp18_;
#line 103 "../bin/dconf-update.vala"
				_tmp6_ = g_key_file_new ();
#line 103 "../bin/dconf-update.vala"
				kf = _tmp6_;
#line 735 "dconf-update.c"
				{
					GKeyFile* _tmp7_;
					const gchar* _tmp8_;
#line 106 "../bin/dconf-update.vala"
					_tmp7_ = kf;
#line 106 "../bin/dconf-update.vala"
					_tmp8_ = filename;
#line 106 "../bin/dconf-update.vala"
					g_key_file_load_from_file (_tmp7_, _tmp8_, G_KEY_FILE_NONE, &_inner_error_);
#line 106 "../bin/dconf-update.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 747 "dconf-update.c"
						goto __catch1_g_error;
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp9_;
					const gchar* _tmp10_;
					GError* _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					GError* _tmp14_;
					GError* _tmp15_;
#line 105 "../bin/dconf-update.vala"
					e = _inner_error_;
#line 105 "../bin/dconf-update.vala"
					_inner_error_ = NULL;
#line 108 "../bin/dconf-update.vala"
					_tmp9_ = e;
#line 108 "../bin/dconf-update.vala"
					_tmp10_ = filename;
#line 108 "../bin/dconf-update.vala"
					_tmp11_ = e;
#line 108 "../bin/dconf-update.vala"
					_tmp12_ = _tmp11_->message;
#line 108 "../bin/dconf-update.vala"
					_tmp13_ = g_strdup_printf ("warning: Failed to read keyfile '%s': %s", _tmp10_, _tmp12_);
#line 108 "../bin/dconf-update.vala"
					_g_free0 (_tmp9_->message);
#line 108 "../bin/dconf-update.vala"
					_tmp9_->message = _tmp13_;
#line 109 "../bin/dconf-update.vala"
					_tmp14_ = e;
#line 109 "../bin/dconf-update.vala"
					_tmp15_ = _g_error_copy0 (_tmp14_);
#line 109 "../bin/dconf-update.vala"
					_inner_error_ = _tmp15_;
#line 109 "../bin/dconf-update.vala"
					_g_error_free0 (e);
#line 788 "dconf-update.c"
					goto __finally1;
				}
				__finally1:
#line 105 "../bin/dconf-update.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 105 "../bin/dconf-update.vala"
					g_propagate_error (error, _inner_error_);
#line 105 "../bin/dconf-update.vala"
					_g_key_file_unref0 (kf);
#line 105 "../bin/dconf-update.vala"
					_g_free0 (filename);
#line 105 "../bin/dconf-update.vala"
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 105 "../bin/dconf-update.vala"
					_g_hash_table_unref0 (table);
#line 105 "../bin/dconf-update.vala"
					return NULL;
#line 806 "dconf-update.c"
				}
#line 112 "../bin/dconf-update.vala"
				_tmp16_ = kf;
#line 112 "../bin/dconf-update.vala"
				_tmp18_ = g_key_file_get_groups (_tmp16_, &_tmp17_);
#line 812 "dconf-update.c"
				{
					gchar** group_collection = NULL;
					gint group_collection_length1 = 0;
					gint _group_collection_size_ = 0;
					gint group_it = 0;
#line 112 "../bin/dconf-update.vala"
					group_collection = _tmp18_;
#line 112 "../bin/dconf-update.vala"
					group_collection_length1 = _tmp17_;
#line 112 "../bin/dconf-update.vala"
					for (group_it = 0; group_it < _tmp17_; group_it = group_it + 1) {
#line 824 "dconf-update.c"
						gchar* _tmp19_;
						gchar* group = NULL;
#line 112 "../bin/dconf-update.vala"
						_tmp19_ = g_strdup (group_collection[group_it]);
#line 112 "../bin/dconf-update.vala"
						group = _tmp19_;
#line 831 "dconf-update.c"
						{
							gboolean _tmp20_ = FALSE;
							gboolean _tmp21_ = FALSE;
							const gchar* _tmp22_;
							gchar** _tmp31_ = NULL;
							GKeyFile* _tmp32_;
							const gchar* _tmp33_;
							gsize _tmp34_ = 0;
							gchar** _tmp35_;
							gint _tmp31__length1;
							gint __tmp31__size_;
#line 113 "../bin/dconf-update.vala"
							_tmp22_ = group;
#line 113 "../bin/dconf-update.vala"
							if (g_str_has_prefix (_tmp22_, "/")) {
#line 113 "../bin/dconf-update.vala"
								_tmp21_ = TRUE;
#line 849 "dconf-update.c"
							} else {
								const gchar* _tmp23_;
#line 113 "../bin/dconf-update.vala"
								_tmp23_ = group;
#line 113 "../bin/dconf-update.vala"
								_tmp21_ = g_str_has_suffix (_tmp23_, "/");
#line 856 "dconf-update.c"
							}
#line 113 "../bin/dconf-update.vala"
							if (_tmp21_) {
#line 113 "../bin/dconf-update.vala"
								_tmp20_ = TRUE;
#line 862 "dconf-update.c"
							} else {
								const gchar* _tmp24_;
#line 113 "../bin/dconf-update.vala"
								_tmp24_ = group;
#line 113 "../bin/dconf-update.vala"
								_tmp20_ = string_contains (_tmp24_, "//");
#line 869 "dconf-update.c"
							}
#line 113 "../bin/dconf-update.vala"
							if (_tmp20_) {
#line 873 "dconf-update.c"
								const gchar* _tmp25_;
								const gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								GError* _tmp29_;
								GError* _tmp30_;
#line 114 "../bin/dconf-update.vala"
								_tmp25_ = filename;
#line 114 "../bin/dconf-update.vala"
								_tmp26_ = group;
#line 114 "../bin/dconf-update.vala"
								_tmp27_ = g_strdup_printf ("%s: invalid group name: %s", _tmp25_, _tmp26_);
#line 114 "../bin/dconf-update.vala"
								_tmp28_ = _tmp27_;
#line 114 "../bin/dconf-update.vala"
								_tmp29_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE, _tmp28_);
#line 114 "../bin/dconf-update.vala"
								_tmp30_ = _tmp29_;
#line 114 "../bin/dconf-update.vala"
								_g_free0 (_tmp28_);
#line 114 "../bin/dconf-update.vala"
								_inner_error_ = _tmp30_;
#line 114 "../bin/dconf-update.vala"
								g_propagate_error (error, _inner_error_);
#line 114 "../bin/dconf-update.vala"
								_g_free0 (group);
#line 114 "../bin/dconf-update.vala"
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 114 "../bin/dconf-update.vala"
								_g_key_file_unref0 (kf);
#line 114 "../bin/dconf-update.vala"
								_g_free0 (filename);
#line 114 "../bin/dconf-update.vala"
								(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 114 "../bin/dconf-update.vala"
								_g_hash_table_unref0 (table);
#line 114 "../bin/dconf-update.vala"
								return NULL;
#line 912 "dconf-update.c"
							}
#line 117 "../bin/dconf-update.vala"
							_tmp32_ = kf;
#line 117 "../bin/dconf-update.vala"
							_tmp33_ = group;
#line 117 "../bin/dconf-update.vala"
							_tmp35_ = g_key_file_get_keys (_tmp32_, _tmp33_, &_tmp34_, &_inner_error_);
#line 117 "../bin/dconf-update.vala"
							_tmp31_ = _tmp35_;
#line 117 "../bin/dconf-update.vala"
							_tmp31__length1 = _tmp34_;
#line 117 "../bin/dconf-update.vala"
							__tmp31__size_ = _tmp31__length1;
#line 117 "../bin/dconf-update.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 117 "../bin/dconf-update.vala"
								g_propagate_error (error, _inner_error_);
#line 117 "../bin/dconf-update.vala"
								_g_free0 (group);
#line 117 "../bin/dconf-update.vala"
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 117 "../bin/dconf-update.vala"
								_g_key_file_unref0 (kf);
#line 117 "../bin/dconf-update.vala"
								_g_free0 (filename);
#line 117 "../bin/dconf-update.vala"
								(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 117 "../bin/dconf-update.vala"
								_g_hash_table_unref0 (table);
#line 117 "../bin/dconf-update.vala"
								return NULL;
#line 944 "dconf-update.c"
							}
							{
								gchar** key_collection = NULL;
								gint key_collection_length1 = 0;
								gint _key_collection_size_ = 0;
								gint key_it = 0;
#line 117 "../bin/dconf-update.vala"
								key_collection = _tmp31_;
#line 117 "../bin/dconf-update.vala"
								key_collection_length1 = _tmp31__length1;
#line 117 "../bin/dconf-update.vala"
								for (key_it = 0; key_it < _tmp31__length1; key_it = key_it + 1) {
#line 957 "dconf-update.c"
									gchar* _tmp36_;
									gchar* key = NULL;
#line 117 "../bin/dconf-update.vala"
									_tmp36_ = g_strdup (key_collection[key_it]);
#line 117 "../bin/dconf-update.vala"
									key = _tmp36_;
#line 964 "dconf-update.c"
									{
										const gchar* _tmp37_;
										gchar* path = NULL;
										const gchar* _tmp42_;
										gchar* _tmp43_;
										gchar* _tmp44_;
										gchar* _tmp45_;
										gchar* _tmp46_;
										const gchar* _tmp47_;
										gchar* _tmp48_;
										gchar* _tmp49_;
										GHashTable* _tmp50_;
										const gchar* _tmp51_;
										gconstpointer _tmp52_;
										gchar* text = NULL;
										GKeyFile* _tmp53_;
										const gchar* _tmp54_;
										const gchar* _tmp55_;
										gchar* _tmp56_;
#line 118 "../bin/dconf-update.vala"
										_tmp37_ = key;
#line 118 "../bin/dconf-update.vala"
										if (string_contains (_tmp37_, "/")) {
#line 988 "dconf-update.c"
											const gchar* _tmp38_;
											const gchar* _tmp39_;
											const gchar* _tmp40_;
											GError* _tmp41_;
#line 119 "../bin/dconf-update.vala"
											_tmp38_ = filename;
#line 119 "../bin/dconf-update.vala"
											_tmp39_ = group;
#line 119 "../bin/dconf-update.vala"
											_tmp40_ = key;
#line 119 "../bin/dconf-update.vala"
											_tmp41_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, "%s: [%s]: invalid key name: %s", _tmp38_, _tmp39_, _tmp40_);
#line 119 "../bin/dconf-update.vala"
											_inner_error_ = _tmp41_;
#line 119 "../bin/dconf-update.vala"
											g_propagate_error (error, _inner_error_);
#line 119 "../bin/dconf-update.vala"
											_g_free0 (key);
#line 119 "../bin/dconf-update.vala"
											_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 119 "../bin/dconf-update.vala"
											_g_free0 (group);
#line 119 "../bin/dconf-update.vala"
											group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 119 "../bin/dconf-update.vala"
											_g_key_file_unref0 (kf);
#line 119 "../bin/dconf-update.vala"
											_g_free0 (filename);
#line 119 "../bin/dconf-update.vala"
											(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 119 "../bin/dconf-update.vala"
											_g_hash_table_unref0 (table);
#line 119 "../bin/dconf-update.vala"
											return NULL;
#line 1023 "dconf-update.c"
										}
#line 123 "../bin/dconf-update.vala"
										_tmp42_ = group;
#line 123 "../bin/dconf-update.vala"
										_tmp43_ = g_strconcat ("/", _tmp42_, NULL);
#line 123 "../bin/dconf-update.vala"
										_tmp44_ = _tmp43_;
#line 123 "../bin/dconf-update.vala"
										_tmp45_ = g_strconcat (_tmp44_, "/", NULL);
#line 123 "../bin/dconf-update.vala"
										_tmp46_ = _tmp45_;
#line 123 "../bin/dconf-update.vala"
										_tmp47_ = key;
#line 123 "../bin/dconf-update.vala"
										_tmp48_ = g_strconcat (_tmp46_, _tmp47_, NULL);
#line 123 "../bin/dconf-update.vala"
										_tmp49_ = _tmp48_;
#line 123 "../bin/dconf-update.vala"
										_g_free0 (_tmp46_);
#line 123 "../bin/dconf-update.vala"
										_g_free0 (_tmp44_);
#line 123 "../bin/dconf-update.vala"
										path = _tmp49_;
#line 125 "../bin/dconf-update.vala"
										_tmp50_ = table;
#line 125 "../bin/dconf-update.vala"
										_tmp51_ = path;
#line 125 "../bin/dconf-update.vala"
										_tmp52_ = g_hash_table_lookup (_tmp50_, _tmp51_);
#line 125 "../bin/dconf-update.vala"
										if (((GvdbItem*) _tmp52_) != NULL) {
#line 130 "../bin/dconf-update.vala"
											_g_free0 (path);
#line 130 "../bin/dconf-update.vala"
											_g_free0 (key);
#line 130 "../bin/dconf-update.vala"
											continue;
#line 1061 "dconf-update.c"
										}
#line 133 "../bin/dconf-update.vala"
										_tmp53_ = kf;
#line 133 "../bin/dconf-update.vala"
										_tmp54_ = group;
#line 133 "../bin/dconf-update.vala"
										_tmp55_ = key;
#line 133 "../bin/dconf-update.vala"
										_tmp56_ = g_key_file_get_value (_tmp53_, _tmp54_, _tmp55_, &_inner_error_);
#line 133 "../bin/dconf-update.vala"
										text = _tmp56_;
#line 133 "../bin/dconf-update.vala"
										if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 133 "../bin/dconf-update.vala"
											g_propagate_error (error, _inner_error_);
#line 133 "../bin/dconf-update.vala"
											_g_free0 (path);
#line 133 "../bin/dconf-update.vala"
											_g_free0 (key);
#line 133 "../bin/dconf-update.vala"
											_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 133 "../bin/dconf-update.vala"
											_g_free0 (group);
#line 133 "../bin/dconf-update.vala"
											group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 133 "../bin/dconf-update.vala"
											_g_key_file_unref0 (kf);
#line 133 "../bin/dconf-update.vala"
											_g_free0 (filename);
#line 133 "../bin/dconf-update.vala"
											(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 133 "../bin/dconf-update.vala"
											_g_hash_table_unref0 (table);
#line 133 "../bin/dconf-update.vala"
											return NULL;
#line 1097 "dconf-update.c"
										}
										{
											GVariant* value = NULL;
											const gchar* _tmp57_;
											GVariant* _tmp58_;
											GvdbItem* item = NULL;
											GHashTable* _tmp59_;
											const gchar* _tmp60_;
											GvdbItem* _tmp61_;
											GvdbItem* _tmp62_;
											GHashTable* _tmp63_;
											const gchar* _tmp64_;
											GvdbItem* _tmp65_;
											GvdbItem* _tmp66_;
											GVariant* _tmp67_;
#line 136 "../bin/dconf-update.vala"
											_tmp57_ = text;
#line 136 "../bin/dconf-update.vala"
											_tmp58_ = g_variant_parse (NULL, _tmp57_, NULL, NULL, &_inner_error_);
#line 136 "../bin/dconf-update.vala"
											value = _tmp58_;
#line 136 "../bin/dconf-update.vala"
											if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 136 "../bin/dconf-update.vala"
												if (_inner_error_->domain == G_VARIANT_PARSE_ERROR) {
#line 1123 "dconf-update.c"
													goto __catch2_g_variant_parse_error;
												}
#line 136 "../bin/dconf-update.vala"
												_g_free0 (text);
#line 136 "../bin/dconf-update.vala"
												_g_free0 (path);
#line 136 "../bin/dconf-update.vala"
												_g_free0 (key);
#line 136 "../bin/dconf-update.vala"
												_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 136 "../bin/dconf-update.vala"
												_g_free0 (group);
#line 136 "../bin/dconf-update.vala"
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 136 "../bin/dconf-update.vala"
												_g_key_file_unref0 (kf);
#line 136 "../bin/dconf-update.vala"
												_g_free0 (filename);
#line 136 "../bin/dconf-update.vala"
												(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 136 "../bin/dconf-update.vala"
												_g_hash_table_unref0 (table);
#line 136 "../bin/dconf-update.vala"
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 136 "../bin/dconf-update.vala"
												g_clear_error (&_inner_error_);
#line 136 "../bin/dconf-update.vala"
												return NULL;
#line 1152 "dconf-update.c"
											}
#line 137 "../bin/dconf-update.vala"
											_tmp59_ = table;
#line 137 "../bin/dconf-update.vala"
											_tmp60_ = path;
#line 137 "../bin/dconf-update.vala"
											_tmp61_ = gvdb_hash_table_insert (_tmp59_, _tmp60_);
#line 137 "../bin/dconf-update.vala"
											item = _tmp61_;
#line 138 "../bin/dconf-update.vala"
											_tmp62_ = item;
#line 138 "../bin/dconf-update.vala"
											_tmp63_ = table;
#line 138 "../bin/dconf-update.vala"
											_tmp64_ = path;
#line 138 "../bin/dconf-update.vala"
											_tmp65_ = get_parent (_tmp63_, _tmp64_);
#line 138 "../bin/dconf-update.vala"
											gvdb_item_set_parent (_tmp62_, _tmp65_);
#line 139 "../bin/dconf-update.vala"
											_tmp66_ = item;
#line 139 "../bin/dconf-update.vala"
											_tmp67_ = value;
#line 139 "../bin/dconf-update.vala"
											gvdb_item_set_value (_tmp66_, _tmp67_);
#line 135 "../bin/dconf-update.vala"
											_g_variant_unref0 (value);
#line 1180 "dconf-update.c"
										}
										goto __finally2;
										__catch2_g_variant_parse_error:
										{
											GError* e = NULL;
											GError* _tmp68_;
											const gchar* _tmp69_;
											const gchar* _tmp70_;
											const gchar* _tmp71_;
											const gchar* _tmp72_;
											GError* _tmp73_;
											const gchar* _tmp74_;
											gchar* _tmp75_;
											GError* _tmp76_;
											GError* _tmp77_;
#line 135 "../bin/dconf-update.vala"
											e = _inner_error_;
#line 135 "../bin/dconf-update.vala"
											_inner_error_ = NULL;
#line 141 "../bin/dconf-update.vala"
											_tmp68_ = e;
#line 141 "../bin/dconf-update.vala"
											_tmp69_ = filename;
#line 141 "../bin/dconf-update.vala"
											_tmp70_ = group;
#line 141 "../bin/dconf-update.vala"
											_tmp71_ = key;
#line 141 "../bin/dconf-update.vala"
											_tmp72_ = text;
#line 141 "../bin/dconf-update.vala"
											_tmp73_ = e;
#line 141 "../bin/dconf-update.vala"
											_tmp74_ = _tmp73_->message;
#line 141 "../bin/dconf-update.vala"
											_tmp75_ = g_strdup_printf ("%s: [%s]: %s: invalid value: %s (%s)", _tmp69_, _tmp70_, _tmp71_, _tmp72_, _tmp74_);
#line 141 "../bin/dconf-update.vala"
											_g_free0 (_tmp68_->message);
#line 141 "../bin/dconf-update.vala"
											_tmp68_->message = _tmp75_;
#line 142 "../bin/dconf-update.vala"
											_tmp76_ = e;
#line 142 "../bin/dconf-update.vala"
											_tmp77_ = _g_error_copy0 (_tmp76_);
#line 142 "../bin/dconf-update.vala"
											_inner_error_ = _tmp77_;
#line 142 "../bin/dconf-update.vala"
											_g_error_free0 (e);
#line 1228 "dconf-update.c"
											goto __finally2;
										}
										__finally2:
#line 135 "../bin/dconf-update.vala"
										if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 135 "../bin/dconf-update.vala"
											g_propagate_error (error, _inner_error_);
#line 135 "../bin/dconf-update.vala"
											_g_free0 (text);
#line 135 "../bin/dconf-update.vala"
											_g_free0 (path);
#line 135 "../bin/dconf-update.vala"
											_g_free0 (key);
#line 135 "../bin/dconf-update.vala"
											_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 135 "../bin/dconf-update.vala"
											_g_free0 (group);
#line 135 "../bin/dconf-update.vala"
											group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 135 "../bin/dconf-update.vala"
											_g_key_file_unref0 (kf);
#line 135 "../bin/dconf-update.vala"
											_g_free0 (filename);
#line 135 "../bin/dconf-update.vala"
											(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 135 "../bin/dconf-update.vala"
											_g_hash_table_unref0 (table);
#line 135 "../bin/dconf-update.vala"
											return NULL;
#line 1258 "dconf-update.c"
										}
#line 117 "../bin/dconf-update.vala"
										_g_free0 (text);
#line 117 "../bin/dconf-update.vala"
										_g_free0 (path);
#line 117 "../bin/dconf-update.vala"
										_g_free0 (key);
#line 1266 "dconf-update.c"
									}
								}
							}
#line 112 "../bin/dconf-update.vala"
							_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 112 "../bin/dconf-update.vala"
							_g_free0 (group);
#line 1274 "dconf-update.c"
						}
					}
#line 112 "../bin/dconf-update.vala"
					group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1279 "dconf-update.c"
				}
#line 102 "../bin/dconf-update.vala"
				_g_key_file_unref0 (kf);
#line 102 "../bin/dconf-update.vala"
				_g_free0 (filename);
#line 1285 "dconf-update.c"
			}
		}
	}
#line 148 "../bin/dconf-update.vala"
	_tmp78_ = g_strconcat (dirname, "/locks", NULL);
#line 148 "../bin/dconf-update.vala"
	_tmp79_ = _tmp78_;
#line 148 "../bin/dconf-update.vala"
	_tmp80_ = read_locks_directory (_tmp79_, &_inner_error_);
#line 148 "../bin/dconf-update.vala"
	_tmp81_ = _tmp80_;
#line 148 "../bin/dconf-update.vala"
	_g_free0 (_tmp79_);
#line 148 "../bin/dconf-update.vala"
	locks = _tmp81_;
#line 148 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 148 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 148 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 148 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 148 "../bin/dconf-update.vala"
		return NULL;
#line 1311 "dconf-update.c"
	}
#line 150 "../bin/dconf-update.vala"
	_tmp82_ = locks;
#line 150 "../bin/dconf-update.vala"
	if (_tmp82_ != NULL) {
#line 1317 "dconf-update.c"
		GvdbItem* item = NULL;
		GHashTable* _tmp83_;
		GvdbItem* _tmp84_;
		GvdbItem* _tmp85_;
		GHashTable* _tmp86_;
#line 151 "../bin/dconf-update.vala"
		_tmp83_ = table;
#line 151 "../bin/dconf-update.vala"
		_tmp84_ = gvdb_hash_table_insert (_tmp83_, ".locks");
#line 151 "../bin/dconf-update.vala"
		item = _tmp84_;
#line 152 "../bin/dconf-update.vala"
		_tmp85_ = item;
#line 152 "../bin/dconf-update.vala"
		_tmp86_ = locks;
#line 152 "../bin/dconf-update.vala"
		gvdb_item_set_hash_table (_tmp85_, _tmp86_);
#line 1335 "dconf-update.c"
	}
#line 155 "../bin/dconf-update.vala"
	result = table;
#line 155 "../bin/dconf-update.vala"
	_g_hash_table_unref0 (locks);
#line 155 "../bin/dconf-update.vala"
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 155 "../bin/dconf-update.vala"
	return result;
#line 1345 "dconf-update.c"
}

time_t
get_directory_mtime (const gchar* dirname,
                     struct stat* dir_buf,
                     GError** error)
{
	time_t result = 0;
	struct stat lockdir_buf = {0};
	struct stat file_buf = {0};
	time_t latest_mtime = 0;
	struct stat _tmp0_;
	GSList* files = NULL;
	GSList* _tmp1_;
	GSList* _tmp3_;
	gboolean _tmp11_ = FALSE;
	gchar* _tmp12_;
	gchar* _tmp13_;
	struct stat _tmp14_ = {0};
	gint _tmp15_;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 158 "../bin/dconf-update.vala"
	g_return_val_if_fail (dirname != NULL, 0);
#line 158 "../bin/dconf-update.vala"
	g_return_val_if_fail (dir_buf != NULL, 0);
#line 161 "../bin/dconf-update.vala"
	_tmp0_ = *dir_buf;
#line 161 "../bin/dconf-update.vala"
	latest_mtime = _tmp0_.st_mtime;
#line 163 "../bin/dconf-update.vala"
	_tmp1_ = list_directory (dirname, S_IFREG, &_inner_error_);
#line 163 "../bin/dconf-update.vala"
	files = _tmp1_;
#line 163 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1382 "dconf-update.c"
		time_t _tmp2_ = 0;
#line 163 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 163 "../bin/dconf-update.vala"
		return _tmp2_;
#line 1388 "dconf-update.c"
	}
#line 165 "../bin/dconf-update.vala"
	_tmp3_ = files;
#line 1392 "dconf-update.c"
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
#line 165 "../bin/dconf-update.vala"
		filename_collection = _tmp3_;
#line 165 "../bin/dconf-update.vala"
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
#line 1400 "dconf-update.c"
			gchar* _tmp4_;
			gchar* filename = NULL;
#line 165 "../bin/dconf-update.vala"
			_tmp4_ = g_strdup ((const gchar*) filename_it->data);
#line 165 "../bin/dconf-update.vala"
			filename = _tmp4_;
#line 1407 "dconf-update.c"
			{
				gboolean _tmp5_ = FALSE;
				const gchar* _tmp6_;
				struct stat _tmp7_ = {0};
				gint _tmp8_;
#line 166 "../bin/dconf-update.vala"
				_tmp6_ = filename;
#line 166 "../bin/dconf-update.vala"
				_tmp8_ = stat (_tmp6_, &_tmp7_);
#line 166 "../bin/dconf-update.vala"
				file_buf = _tmp7_;
#line 166 "../bin/dconf-update.vala"
				if (_tmp8_ == 0) {
#line 1421 "dconf-update.c"
					struct stat _tmp9_;
#line 166 "../bin/dconf-update.vala"
					_tmp9_ = file_buf;
#line 166 "../bin/dconf-update.vala"
					_tmp5_ = _tmp9_.st_mtime > latest_mtime;
#line 1427 "dconf-update.c"
				} else {
#line 166 "../bin/dconf-update.vala"
					_tmp5_ = FALSE;
#line 1431 "dconf-update.c"
				}
#line 166 "../bin/dconf-update.vala"
				if (_tmp5_) {
#line 1435 "dconf-update.c"
					struct stat _tmp10_;
#line 167 "../bin/dconf-update.vala"
					_tmp10_ = file_buf;
#line 167 "../bin/dconf-update.vala"
					latest_mtime = _tmp10_.st_mtime;
#line 1441 "dconf-update.c"
				}
#line 165 "../bin/dconf-update.vala"
				_g_free0 (filename);
#line 1445 "dconf-update.c"
			}
		}
	}
#line 170 "../bin/dconf-update.vala"
	_tmp12_ = g_strconcat (dirname, "/locks", NULL);
#line 170 "../bin/dconf-update.vala"
	_tmp13_ = _tmp12_;
#line 170 "../bin/dconf-update.vala"
	_tmp15_ = stat (_tmp13_, &_tmp14_);
#line 170 "../bin/dconf-update.vala"
	lockdir_buf = _tmp14_;
#line 170 "../bin/dconf-update.vala"
	_tmp16_ = _tmp15_ == 0;
#line 170 "../bin/dconf-update.vala"
	_g_free0 (_tmp13_);
#line 170 "../bin/dconf-update.vala"
	if (_tmp16_) {
#line 1463 "dconf-update.c"
		struct stat _tmp17_;
#line 170 "../bin/dconf-update.vala"
		_tmp17_ = lockdir_buf;
#line 170 "../bin/dconf-update.vala"
		_tmp11_ = S_ISDIR (_tmp17_.st_mode);
#line 1469 "dconf-update.c"
	} else {
#line 170 "../bin/dconf-update.vala"
		_tmp11_ = FALSE;
#line 1473 "dconf-update.c"
	}
#line 170 "../bin/dconf-update.vala"
	if (_tmp11_) {
#line 1477 "dconf-update.c"
		struct stat _tmp18_;
		GSList* _tmp20_ = NULL;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GSList* _tmp23_;
		GSList* _tmp24_;
		GSList* _tmp26_;
		GSList* _tmp27_;
#line 171 "../bin/dconf-update.vala"
		_tmp18_ = lockdir_buf;
#line 171 "../bin/dconf-update.vala"
		if (_tmp18_.st_mtime > latest_mtime) {
#line 1490 "dconf-update.c"
			struct stat _tmp19_;
#line 173 "../bin/dconf-update.vala"
			_tmp19_ = lockdir_buf;
#line 173 "../bin/dconf-update.vala"
			latest_mtime = _tmp19_.st_mtime;
#line 1496 "dconf-update.c"
		}
#line 176 "../bin/dconf-update.vala"
		_tmp21_ = g_strconcat (dirname, "/locks", NULL);
#line 176 "../bin/dconf-update.vala"
		_tmp22_ = _tmp21_;
#line 176 "../bin/dconf-update.vala"
		_tmp23_ = list_directory (_tmp22_, S_IFREG, &_inner_error_);
#line 176 "../bin/dconf-update.vala"
		_tmp24_ = _tmp23_;
#line 176 "../bin/dconf-update.vala"
		_g_free0 (_tmp22_);
#line 176 "../bin/dconf-update.vala"
		_tmp20_ = _tmp24_;
#line 176 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1512 "dconf-update.c"
			time_t _tmp25_ = 0;
#line 176 "../bin/dconf-update.vala"
			g_propagate_error (error, _inner_error_);
#line 176 "../bin/dconf-update.vala"
			(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 176 "../bin/dconf-update.vala"
			return _tmp25_;
#line 1520 "dconf-update.c"
		}
#line 176 "../bin/dconf-update.vala"
		_tmp26_ = _tmp20_;
#line 176 "../bin/dconf-update.vala"
		_tmp20_ = NULL;
#line 176 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 176 "../bin/dconf-update.vala"
		files = _tmp26_;
#line 178 "../bin/dconf-update.vala"
		_tmp27_ = files;
#line 1532 "dconf-update.c"
		{
			GSList* filename_collection = NULL;
			GSList* filename_it = NULL;
#line 178 "../bin/dconf-update.vala"
			filename_collection = _tmp27_;
#line 178 "../bin/dconf-update.vala"
			for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
#line 1540 "dconf-update.c"
				gchar* _tmp28_;
				gchar* filename = NULL;
#line 178 "../bin/dconf-update.vala"
				_tmp28_ = g_strdup ((const gchar*) filename_it->data);
#line 178 "../bin/dconf-update.vala"
				filename = _tmp28_;
#line 1547 "dconf-update.c"
				{
					gboolean _tmp29_ = FALSE;
					const gchar* _tmp30_;
					struct stat _tmp31_ = {0};
					gint _tmp32_;
#line 179 "../bin/dconf-update.vala"
					_tmp30_ = filename;
#line 179 "../bin/dconf-update.vala"
					_tmp32_ = stat (_tmp30_, &_tmp31_);
#line 179 "../bin/dconf-update.vala"
					file_buf = _tmp31_;
#line 179 "../bin/dconf-update.vala"
					if (_tmp32_ == 0) {
#line 1561 "dconf-update.c"
						struct stat _tmp33_;
#line 179 "../bin/dconf-update.vala"
						_tmp33_ = file_buf;
#line 179 "../bin/dconf-update.vala"
						_tmp29_ = _tmp33_.st_mtime > latest_mtime;
#line 1567 "dconf-update.c"
					} else {
#line 179 "../bin/dconf-update.vala"
						_tmp29_ = FALSE;
#line 1571 "dconf-update.c"
					}
#line 179 "../bin/dconf-update.vala"
					if (_tmp29_) {
#line 1575 "dconf-update.c"
						struct stat _tmp34_;
#line 180 "../bin/dconf-update.vala"
						_tmp34_ = file_buf;
#line 180 "../bin/dconf-update.vala"
						latest_mtime = _tmp34_.st_mtime;
#line 1581 "dconf-update.c"
					}
#line 178 "../bin/dconf-update.vala"
					_g_free0 (filename);
#line 1585 "dconf-update.c"
				}
			}
		}
#line 170 "../bin/dconf-update.vala"
		(_tmp20_ == NULL) ? NULL : (_tmp20_ = (_g_slist_free__g_free0_ (_tmp20_), NULL));
#line 1591 "dconf-update.c"
	}
#line 184 "../bin/dconf-update.vala"
	result = latest_mtime;
#line 184 "../bin/dconf-update.vala"
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 184 "../bin/dconf-update.vala"
	return result;
#line 1599 "dconf-update.c"
}

void
maybe_update_from_directory (const gchar* dirname,
                             GError** error)
{
	struct stat dir_buf = {0};
	gboolean _tmp0_ = FALSE;
	struct stat _tmp1_ = {0};
	gint _tmp2_;
	GError * _inner_error_ = NULL;
#line 187 "../bin/dconf-update.vala"
	g_return_if_fail (dirname != NULL);
#line 190 "../bin/dconf-update.vala"
	_tmp2_ = stat (dirname, &_tmp1_);
#line 190 "../bin/dconf-update.vala"
	dir_buf = _tmp1_;
#line 190 "../bin/dconf-update.vala"
	if (_tmp2_ == 0) {
#line 1619 "dconf-update.c"
		struct stat _tmp3_;
#line 190 "../bin/dconf-update.vala"
		_tmp3_ = dir_buf;
#line 190 "../bin/dconf-update.vala"
		_tmp0_ = S_ISDIR (_tmp3_.st_mode);
#line 1625 "dconf-update.c"
	} else {
#line 190 "../bin/dconf-update.vala"
		_tmp0_ = FALSE;
#line 1629 "dconf-update.c"
	}
#line 190 "../bin/dconf-update.vala"
	if (_tmp0_) {
#line 1633 "dconf-update.c"
		struct stat file_buf = {0};
		gchar* filename = NULL;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		struct stat _tmp9_ = {0};
		gint _tmp10_;
		GHashTable* table = NULL;
		GHashTable* _tmp14_;
		gint fd = 0;
		const gchar* _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 193 "../bin/dconf-update.vala"
		_tmp4_ = strlen (dirname);
#line 193 "../bin/dconf-update.vala"
		_tmp5_ = _tmp4_;
#line 193 "../bin/dconf-update.vala"
		_tmp6_ = string_substring (dirname, (glong) 0, (glong) (_tmp5_ - 2));
#line 193 "../bin/dconf-update.vala"
		filename = _tmp6_;
#line 195 "../bin/dconf-update.vala"
		_tmp8_ = filename;
#line 195 "../bin/dconf-update.vala"
		_tmp10_ = stat (_tmp8_, &_tmp9_);
#line 195 "../bin/dconf-update.vala"
		file_buf = _tmp9_;
#line 195 "../bin/dconf-update.vala"
		if (_tmp10_ == 0) {
#line 1664 "dconf-update.c"
			time_t _tmp11_ = 0;
			struct stat _tmp12_;
			struct stat _tmp13_;
#line 195 "../bin/dconf-update.vala"
			_tmp12_ = dir_buf;
#line 195 "../bin/dconf-update.vala"
			_tmp11_ = get_directory_mtime (dirname, &_tmp12_, &_inner_error_);
#line 195 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 195 "../bin/dconf-update.vala"
				g_propagate_error (error, _inner_error_);
#line 195 "../bin/dconf-update.vala"
				_g_free0 (filename);
#line 195 "../bin/dconf-update.vala"
				return;
#line 1680 "dconf-update.c"
			}
#line 195 "../bin/dconf-update.vala"
			_tmp13_ = file_buf;
#line 195 "../bin/dconf-update.vala"
			_tmp7_ = _tmp13_.st_mtime > _tmp11_;
#line 1686 "dconf-update.c"
		} else {
#line 195 "../bin/dconf-update.vala"
			_tmp7_ = FALSE;
#line 1690 "dconf-update.c"
		}
#line 195 "../bin/dconf-update.vala"
		if (_tmp7_) {
#line 196 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 196 "../bin/dconf-update.vala"
			return;
#line 1698 "dconf-update.c"
		}
#line 199 "../bin/dconf-update.vala"
		_tmp14_ = read_directory (dirname, &_inner_error_);
#line 199 "../bin/dconf-update.vala"
		table = _tmp14_;
#line 199 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 199 "../bin/dconf-update.vala"
			g_propagate_error (error, _inner_error_);
#line 199 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 199 "../bin/dconf-update.vala"
			return;
#line 1712 "dconf-update.c"
		}
#line 201 "../bin/dconf-update.vala"
		_tmp15_ = filename;
#line 201 "../bin/dconf-update.vala"
		fd = open (_tmp15_, O_WRONLY, (mode_t) 0);
#line 203 "../bin/dconf-update.vala"
		if (fd < 0) {
#line 203 "../bin/dconf-update.vala"
			_tmp16_ = errno != ENOENT;
#line 1722 "dconf-update.c"
		} else {
#line 203 "../bin/dconf-update.vala"
			_tmp16_ = FALSE;
#line 1726 "dconf-update.c"
		}
#line 203 "../bin/dconf-update.vala"
		if (_tmp16_) {
#line 1730 "dconf-update.c"
			gint saved_error = 0;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 204 "../bin/dconf-update.vala"
			saved_error = errno;
#line 205 "../bin/dconf-update.vala"
			_tmp17_ = filename;
#line 205 "../bin/dconf-update.vala"
			_tmp18_ = g_strerror (saved_error);
#line 205 "../bin/dconf-update.vala"
			g_printerr ("warning: Failed to open '%s' for replacement: %s\n", _tmp17_, _tmp18_);
#line 206 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 206 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 206 "../bin/dconf-update.vala"
			return;
#line 1748 "dconf-update.c"
		}
		{
			GHashTable* _tmp19_;
			const gchar* _tmp20_;
#line 212 "../bin/dconf-update.vala"
			_tmp19_ = table;
#line 212 "../bin/dconf-update.vala"
			_tmp20_ = filename;
#line 212 "../bin/dconf-update.vala"
			gvdb_table_write_contents (_tmp19_, _tmp20_, FALSE, &_inner_error_);
#line 212 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1761 "dconf-update.c"
				goto __catch3_g_error;
			}
#line 214 "../bin/dconf-update.vala"
			if (fd >= 0) {
#line 215 "../bin/dconf-update.vala"
				write (fd, "\0\0\0\0\0\0\0\0", (gsize) 8);
#line 1768 "dconf-update.c"
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp21_;
			const gchar* _tmp22_;
#line 211 "../bin/dconf-update.vala"
			e = _inner_error_;
#line 211 "../bin/dconf-update.vala"
			_inner_error_ = NULL;
#line 218 "../bin/dconf-update.vala"
			_tmp21_ = e;
#line 218 "../bin/dconf-update.vala"
			_tmp22_ = _tmp21_->message;
#line 218 "../bin/dconf-update.vala"
			g_printerr ("warning: %s\n", _tmp22_);
#line 219 "../bin/dconf-update.vala"
			_g_error_free0 (e);
#line 1789 "dconf-update.c"
			{
#line 221 "../bin/dconf-update.vala"
				if (fd >= 0) {
#line 222 "../bin/dconf-update.vala"
					close (fd);
#line 1795 "dconf-update.c"
				}
			}
#line 219 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 219 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 219 "../bin/dconf-update.vala"
			return;
#line 1804 "dconf-update.c"
		}
		__finally3:
		{
#line 221 "../bin/dconf-update.vala"
			if (fd >= 0) {
#line 222 "../bin/dconf-update.vala"
				close (fd);
#line 1812 "dconf-update.c"
			}
		}
#line 211 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 211 "../bin/dconf-update.vala"
			g_propagate_error (error, _inner_error_);
#line 211 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 211 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 211 "../bin/dconf-update.vala"
			return;
#line 1825 "dconf-update.c"
		}
		{
			GDBusConnection* system_bus = NULL;
			GDBusConnection* _tmp23_;
			GDBusConnection* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			GVariant* _tmp30_;
			GVariant* _tmp31_;
			GDBusConnection* _tmp32_;
#line 227 "../bin/dconf-update.vala"
			_tmp23_ = g_bus_get_sync (G_BUS_TYPE_SYSTEM, NULL, &_inner_error_);
#line 227 "../bin/dconf-update.vala"
			system_bus = _tmp23_;
#line 227 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1845 "dconf-update.c"
				goto __catch4_g_error;
			}
#line 228 "../bin/dconf-update.vala"
			_tmp24_ = system_bus;
#line 228 "../bin/dconf-update.vala"
			_tmp25_ = filename;
#line 228 "../bin/dconf-update.vala"
			_tmp26_ = g_path_get_basename (_tmp25_);
#line 228 "../bin/dconf-update.vala"
			_tmp27_ = _tmp26_;
#line 228 "../bin/dconf-update.vala"
			_tmp28_ = g_strconcat ("/ca/desrt/dconf/Writer/", _tmp27_, NULL);
#line 228 "../bin/dconf-update.vala"
			_tmp29_ = _tmp28_;
#line 228 "../bin/dconf-update.vala"
			_tmp30_ = g_variant_new ("(s)", "/", NULL);
#line 228 "../bin/dconf-update.vala"
			g_variant_ref_sink (_tmp30_);
#line 228 "../bin/dconf-update.vala"
			_tmp31_ = _tmp30_;
#line 228 "../bin/dconf-update.vala"
			g_dbus_connection_emit_signal (_tmp24_, NULL, _tmp29_, "ca.desrt.dconf.Writer", "WritabilityNotify", _tmp31_, &_inner_error_);
#line 228 "../bin/dconf-update.vala"
			_g_variant_unref0 (_tmp31_);
#line 228 "../bin/dconf-update.vala"
			_g_free0 (_tmp29_);
#line 228 "../bin/dconf-update.vala"
			_g_free0 (_tmp27_);
#line 228 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 228 "../bin/dconf-update.vala"
				_g_object_unref0 (system_bus);
#line 1878 "dconf-update.c"
				goto __catch4_g_error;
			}
#line 230 "../bin/dconf-update.vala"
			_tmp32_ = system_bus;
#line 230 "../bin/dconf-update.vala"
			g_dbus_connection_flush_sync (_tmp32_, NULL, &_inner_error_);
#line 230 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 230 "../bin/dconf-update.vala"
				_g_object_unref0 (system_bus);
#line 1889 "dconf-update.c"
				goto __catch4_g_error;
			}
#line 226 "../bin/dconf-update.vala"
			_g_object_unref0 (system_bus);
#line 1894 "dconf-update.c"
		}
		goto __finally4;
		__catch4_g_error:
		{
#line 226 "../bin/dconf-update.vala"
			g_clear_error (&_inner_error_);
#line 226 "../bin/dconf-update.vala"
			_inner_error_ = NULL;
#line 1903 "dconf-update.c"
		}
		__finally4:
#line 226 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 226 "../bin/dconf-update.vala"
			g_propagate_error (error, _inner_error_);
#line 226 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 226 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 226 "../bin/dconf-update.vala"
			return;
#line 1916 "dconf-update.c"
		}
#line 190 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 190 "../bin/dconf-update.vala"
		_g_free0 (filename);
#line 1922 "dconf-update.c"
	}
}

void
update_all (const gchar* dirname,
            GError** error)
{
	gboolean failed = FALSE;
	GSList* _tmp0_ = NULL;
	GSList* _tmp1_;
	GError * _inner_error_ = NULL;
#line 237 "../bin/dconf-update.vala"
	g_return_if_fail (dirname != NULL);
#line 238 "../bin/dconf-update.vala"
	failed = FALSE;
#line 240 "../bin/dconf-update.vala"
	_tmp1_ = list_directory (dirname, S_IFDIR, &_inner_error_);
#line 240 "../bin/dconf-update.vala"
	_tmp0_ = _tmp1_;
#line 240 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 240 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 240 "../bin/dconf-update.vala"
		return;
#line 1948 "dconf-update.c"
	}
	{
		GSList* name_collection = NULL;
		GSList* name_it = NULL;
#line 240 "../bin/dconf-update.vala"
		name_collection = _tmp0_;
#line 240 "../bin/dconf-update.vala"
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
#line 1957 "dconf-update.c"
			gchar* _tmp2_;
			gchar* name = NULL;
#line 240 "../bin/dconf-update.vala"
			_tmp2_ = g_strdup ((const gchar*) name_it->data);
#line 240 "../bin/dconf-update.vala"
			name = _tmp2_;
#line 1964 "dconf-update.c"
			{
				const gchar* _tmp3_;
#line 241 "../bin/dconf-update.vala"
				_tmp3_ = name;
#line 241 "../bin/dconf-update.vala"
				if (g_str_has_suffix (_tmp3_, ".d")) {
#line 1971 "dconf-update.c"
					{
						const gchar* _tmp4_;
#line 243 "../bin/dconf-update.vala"
						_tmp4_ = name;
#line 243 "../bin/dconf-update.vala"
						maybe_update_from_directory (_tmp4_, &_inner_error_);
#line 243 "../bin/dconf-update.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1980 "dconf-update.c"
							goto __catch5_g_error;
						}
					}
					goto __finally5;
					__catch5_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp5_;
						GError* _tmp6_;
						const gchar* _tmp7_;
#line 242 "../bin/dconf-update.vala"
						e = _inner_error_;
#line 242 "../bin/dconf-update.vala"
						_inner_error_ = NULL;
#line 245 "../bin/dconf-update.vala"
						failed = TRUE;
#line 246 "../bin/dconf-update.vala"
						_tmp5_ = name;
#line 246 "../bin/dconf-update.vala"
						_tmp6_ = e;
#line 246 "../bin/dconf-update.vala"
						_tmp7_ = _tmp6_->message;
#line 246 "../bin/dconf-update.vala"
						g_printerr ("unable to compile %s: %s\n", _tmp5_, _tmp7_);
#line 242 "../bin/dconf-update.vala"
						_g_error_free0 (e);
#line 2007 "dconf-update.c"
					}
					__finally5:
#line 242 "../bin/dconf-update.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 242 "../bin/dconf-update.vala"
						g_propagate_error (error, _inner_error_);
#line 242 "../bin/dconf-update.vala"
						_g_free0 (name);
#line 242 "../bin/dconf-update.vala"
						(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
#line 242 "../bin/dconf-update.vala"
						return;
#line 2020 "dconf-update.c"
					}
				}
#line 240 "../bin/dconf-update.vala"
				_g_free0 (name);
#line 2025 "dconf-update.c"
			}
		}
	}
#line 251 "../bin/dconf-update.vala"
	if (failed) {
#line 252 "../bin/dconf-update.vala"
		exit (2);
#line 2033 "dconf-update.c"
	}
#line 237 "../bin/dconf-update.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
#line 2037 "dconf-update.c"
}

void
dconf_compile (gchar** args,
               gint args_length1,
               GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 257 "../bin/dconf-update.vala"
	_tmp2_ = args[2];
#line 257 "../bin/dconf-update.vala"
	if (_tmp2_ == NULL) {
#line 257 "../bin/dconf-update.vala"
		_tmp1_ = TRUE;
#line 2055 "dconf-update.c"
	} else {
		const gchar* _tmp3_;
#line 257 "../bin/dconf-update.vala"
		_tmp3_ = args[3];
#line 257 "../bin/dconf-update.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 2062 "dconf-update.c"
	}
#line 257 "../bin/dconf-update.vala"
	if (_tmp1_) {
#line 257 "../bin/dconf-update.vala"
		_tmp0_ = TRUE;
#line 2068 "dconf-update.c"
	} else {
		const gchar* _tmp4_;
#line 257 "../bin/dconf-update.vala"
		_tmp4_ = args[4];
#line 257 "../bin/dconf-update.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 2075 "dconf-update.c"
	}
#line 257 "../bin/dconf-update.vala"
	if (_tmp0_) {
#line 2079 "dconf-update.c"
		GError* _tmp5_;
#line 258 "../bin/dconf-update.vala"
		_tmp5_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, "must give output file and .d dir");
#line 258 "../bin/dconf-update.vala"
		_inner_error_ = _tmp5_;
#line 258 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 258 "../bin/dconf-update.vala"
		return;
#line 2089 "dconf-update.c"
	}
	{
		GHashTable* table = NULL;
		const gchar* _tmp6_;
		GHashTable* _tmp7_;
		gboolean should_byteswap = FALSE;
		GHashTable* _tmp8_;
		const gchar* _tmp9_;
#line 264 "../bin/dconf-update.vala"
		_tmp6_ = args[3];
#line 264 "../bin/dconf-update.vala"
		_tmp7_ = read_directory (_tmp6_, &_inner_error_);
#line 264 "../bin/dconf-update.vala"
		table = _tmp7_;
#line 264 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2106 "dconf-update.c"
			goto __catch6_g_error;
		}
#line 265 "../bin/dconf-update.vala"
		should_byteswap = G_BYTE_ORDER == G_BIG_ENDIAN;
#line 266 "../bin/dconf-update.vala"
		_tmp8_ = table;
#line 266 "../bin/dconf-update.vala"
		_tmp9_ = args[2];
#line 266 "../bin/dconf-update.vala"
		gvdb_table_write_contents (_tmp8_, _tmp9_, should_byteswap, &_inner_error_);
#line 266 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 266 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 2121 "dconf-update.c"
			goto __catch6_g_error;
		}
#line 261 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 2126 "dconf-update.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
#line 261 "../bin/dconf-update.vala"
		e = _inner_error_;
#line 261 "../bin/dconf-update.vala"
		_inner_error_ = NULL;
#line 268 "../bin/dconf-update.vala"
		_tmp10_ = e->message;
#line 268 "../bin/dconf-update.vala"
		g_printerr ("%s\n", _tmp10_);
#line 269 "../bin/dconf-update.vala"
		exit (1);
#line 261 "../bin/dconf-update.vala"
		_g_error_free0 (e);
#line 2145 "dconf-update.c"
	}
	__finally6:
#line 261 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 261 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 261 "../bin/dconf-update.vala"
		return;
#line 2154 "dconf-update.c"
	}
}

void
dconf_update (gchar** args,
              gint args_length1,
              GError** error)
{
	gint index = 0;
	gchar* dbpath = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
	GError * _inner_error_ = NULL;
#line 277 "../bin/dconf-update.vala"
	index = 2;
#line 278 "../bin/dconf-update.vala"
	_tmp0_ = g_strdup (SYSCONFDIR "/dconf/db");
#line 278 "../bin/dconf-update.vala"
	dbpath = _tmp0_;
#line 280 "../bin/dconf-update.vala"
	_tmp1_ = args[index];
#line 280 "../bin/dconf-update.vala"
	if (_tmp1_ != NULL) {
#line 2180 "dconf-update.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gint _tmp4_;
#line 281 "../bin/dconf-update.vala"
		_tmp2_ = args[index];
#line 281 "../bin/dconf-update.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 281 "../bin/dconf-update.vala"
		_g_free0 (dbpath);
#line 281 "../bin/dconf-update.vala"
		dbpath = _tmp3_;
#line 282 "../bin/dconf-update.vala"
		_tmp4_ = index;
#line 282 "../bin/dconf-update.vala"
		index = _tmp4_ + 1;
#line 2196 "dconf-update.c"
	}
#line 285 "../bin/dconf-update.vala"
	_tmp5_ = args[index];
#line 285 "../bin/dconf-update.vala"
	if (_tmp5_ != NULL) {
#line 2202 "dconf-update.c"
		GError* _tmp6_;
#line 286 "../bin/dconf-update.vala"
		_tmp6_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, "too many arguments");
#line 286 "../bin/dconf-update.vala"
		_inner_error_ = _tmp6_;
#line 286 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 286 "../bin/dconf-update.vala"
		_g_free0 (dbpath);
#line 286 "../bin/dconf-update.vala"
		return;
#line 2214 "dconf-update.c"
	}
#line 289 "../bin/dconf-update.vala"
	_tmp7_ = dbpath;
#line 289 "../bin/dconf-update.vala"
	update_all (_tmp7_, &_inner_error_);
#line 289 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 289 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 289 "../bin/dconf-update.vala"
		_g_free0 (dbpath);
#line 289 "../bin/dconf-update.vala"
		return;
#line 2228 "dconf-update.c"
	}
#line 276 "../bin/dconf-update.vala"
	_g_free0 (dbpath);
#line 2232 "dconf-update.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

